<?php
declare(strict_types=1);

namespace Flat101\EnhancedEcommerce\Block\Impressions;

use Flat101\EnhancedEcommerce\Block\AbstractDatalayer;
use Flat101\EnhancedEcommerce\Model\DataLayer\Impressions\CatalogImpressionView as CatalogImpressionViewUa;
use Flat101\EnhancedEcommerce\Model\DataLayerGa4\Impressions\CatalogImpressionView as CatalogImpressionViewGa4;
use Magento\Framework\View\Element\Template;
use Flat101\EnhancedEcommerce\Api\DataLayerListInterface;
use Flat101\EnhancedEcommerce\Factory\DataLayerFactory;
use Flat101\EnhancedEcommerce\Helper\Config;
use Magento\Framework\App\Response\RedirectInterface;
use Magento\Framework\Event\Manager;
use Magento\Framework\Serialize\SerializerInterface;
use Magento\Framework\UrlInterface;

class CatalogImpression extends AbstractDatalayer
{
    /** @var CatalogImpressionViewUa */
    protected $catalogImpressionViewUa;
    
    /** @var CatalogImpressionViewGa4 */
    protected $catalogImpressionViewGa4;

    public function __construct(
        CatalogImpressionViewUa $catalogImpressionViewUa,
        CatalogImpressionViewGa4 $catalogImpressionViewGa4,
        Template\Context $context,
        DataLayerListInterface $dataLayerList,
        DataLayerFactory $dataLayerFactory,
        SerializerInterface $serializer,
        UrlInterface $url,
        Config $config,
        RedirectInterface $redirect,
        Manager $eventManage,
        array $data = []
    ) {
        parent::__construct($context, $dataLayerList, $dataLayerFactory, $serializer, $url, $config, $redirect, $eventManage, $data);
        $this->catalogImpressionViewUa = $catalogImpressionViewUa;
        $this->catalogImpressionViewGa4 = $catalogImpressionViewGa4;
    }

    public function getJsonDataLayers(): ?string
    {
        $layers['GA4'] = $this->catalogImpressionViewGa4->getLayer();
        
        if (!$this->config->getIsDisabledUaDatalayer()) {
            $layers['UA'] = $this->catalogImpressionViewUa->getLayer();
        }
        
        return $this->serializer->serialize($layers);
    }
}
