<?php
declare(strict_types=1);

namespace Flat101\EnhancedEcommerce\Model\DataLayer;

use Flat101\EnhancedEcommerce\Api\Data\DataLayerInterface;

class CheckoutView implements DataLayerInterface
{
    public const CODE = 'checkout-view';

    const SHIPPING_STEP = 1;
    const SHIPPING_STEP_LABEL = 'step 1 - Shipping info';

    /**
     * @var Generator\CheckoutStep
     */
    private $checkoutStep;

    public function __construct(Generator\CheckoutStep $checkoutStep)
    {
        $this->checkoutStep = $checkoutStep;
    }

    public function getCode(): string
    {
        return self::CODE;
    }

    public function getLayer(): Dto\Ecommerce
    {
        return $this->checkoutStep->onCheckoutStep(self::SHIPPING_STEP, null, self::SHIPPING_STEP_LABEL);
    }
}
