<?php

namespace Flat101\EnhancedEcommerce\Model\DataLayer\Impressions;

use Flat101\EnhancedEcommerce\Api\Data\DataLayerInterface;
use Flat101\EnhancedEcommerce\Model\Session;
use Magento\Framework\Event\Manager;
use Magento\Checkout\Model\Session as ChechkoutSession;
use Magento\Sales\Api\OrderRepositoryInterface;


class SuccessImpressionView implements DataLayerInterface
{
    public const CODE = 'success-impression-view';

    /**
     * @var Session
     */
    private Session $session;

    /**
     * @var Manager
     */
    private $eventManager;

    /**
     * @var ChechkoutSession
     */
    private ChechkoutSession $checkoutSession;

    public function __construct(
        OrderRepositoryInterface $orderRepository,
        Session $session,
        Manager $eventManager,
        ChechkoutSession $checkoutSession
    )
    {
        $this->orderRepository = $orderRepository;
        $this->session = $session;
        $this->eventManager = $eventManager;
        $this->checkoutSession = $checkoutSession;
    }

    public function getCode(): string
    {
        return static::CODE;
    }

    /**
     * {@inheritdoc}
     */
    public function getLayer(): mixed
    {
        $orderId = $this->checkoutSession->getLastOrderId();
        $order = $this->getOrder($orderId);
        $products = $order->getItemsCollection();
        $impression = 0 === \count($products) ? [] : $products;

        $this->eventManager->dispatch('flat101_enhancedecommerce_success_impression_view', [
            'dataLayer' => $impression,
        ]);

        return $impression;
    }
    public function getOrder($id): \Magento\Sales\Api\Data\OrderInterface
    {
        return $this->orderRepository->get($id);
    }

}

