define([
    'jquery',
    'ko',
    'uiComponent',
    'Magento_Checkout/js/model/quote'
], function ($, ko, Component, quote) {
    'use strict';
    return Component.extend({

        initialize: function () {
            this._super();
            const self = this;
            var configValues = window.checkoutConfig;

            $(document).on("click", ".button.action.continue.primary", function () {

            let items = quote.getItems();

            _.each(items, function (item) {
                if (item['qty_options'] === undefined || item['qty_options'].length === 0) {

                    let prodId = item.product_id;
                    let product = item.product;

                    self.dataLayerPush(product, prodId, configValues.GA4);

                    if (_.has(configValues, 'UA') && _.isObject(configValues.UA)) {
                        self.dataLayerPush(product, prodId, configValues.UA);
                    }
                }
            });

            });

            $(document).on("click", ".action.primary.checkout", function () {

            let items = quote.getItems();

            _.each(items, function (item) {
                if (item['qty_options'] === undefined || item['qty_options'].length === 0) {

                    let prodId = item.product_id;
                    let product = item.product;

                    if (_.has(configValues) && _.isObject(configValues.GA4)) {
                        self.dataLayerPush(product, prodId, configValues.GA4);

                        if (_.has(configValues, 'UA') && _.isObject(configValues.UA)) {
                            self.dataLayerPush2(product, prodId, configValues.UA);
                        }
                    }
                }
            });

            });
        },

        initBefore: function () {
            window.dataLayer = window.dataLayer || [];
        },

        dataLayerPush: function (product, prodId, config) {

            const self = this;
            self.initBefore();
            dataLayer.push({
                "event": "checkoutStep",
                "eventCategory": "enhanced ecommerce",
                "eventAction": "checkout",
                "eventLabel": "step 1 - entrega",
                "ecommerce": {
                    "checkout": {
                        "actionField": {
                            "step": 1
                        },
                        "products": [
                            {
                                "id": prodId,
                                "name": product.name,
                                "price": product.price,
                                "quantity": product.qty,
                                "category": product.category,
                            }
                        ]
                    }
                }
            });
        },
        dataLayerPush2: function (product, prodId, config) {

            const self = this;
            self.initBefore();
            dataLayer.push({
                "event": "checkoutStep",
                "eventCategory": "enhanced ecommerce",
                "eventAction": "checkout",
                "eventLabel": "step 2 - pago",
                "ecommerce": {
                    "checkout": {
                        "actionField": {
                            "step": 2
                        },
                        "products": [
                            {
                                "id": prodId,
                                "name": product.name,
                                "price": product.price,
                                "quantity": product.qty,
                                "category": product.category,
                            }
                        ],
                        "option": ''
                    }
                }
            });
        }
    });
})

